/*
Gemma's Battle Abilities

Original Programming by SMS Alfredo
Extra Programming by reverbal
*/

/*
Futureproofing for Uncapped when that gets merged, 
since P_TeleportMove would be deprecated when that happens
*/
local P_MoveOrigin = P_MoveOrigin or P_TeleportMove
local P_SetOrigin = P_SetOrigin or P_TeleportMove

local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(CBW_Battle) or ScriptLoaded then return end
	ScriptLoaded = true
	local B = CBW_Battle
	
	local function GarbagePriority7(player)
		-- rev: avoid warnings...
		if 	(not player.mo)
			or (not player.gemmasmash)
			or (not player.gemmaspindash)
		then return end
	
		if player.gemmasmash == 1 and not P_IsObjectOnGround(player.mo)
			B.SetPriority(player,1,1,"fang_tailbounce",2,1,"ground pound")
			
		elseif player.gemmasmash > 1 and not P_IsObjectOnGround(player.mo)
			B.SetPriority(player,0,0,"fang_tailbounce",2,99,"rock platform")
			
		elseif player.actionstate == 3 and not P_IsObjectOnGround(player.mo)
			B.SetPriority(player,1,1,"fang_tailbounce",3,3,"charged ground pound")
			
		elseif player.gemmaspindash
			B.SetPriority(player,1,1,"fang_tailbounce",2,99,"platform spindash")
		end
	end
	
	//Ability
	local function GemmaBattle(mo,doaction)
		local player = mo.player
		
		-- rev: Actionstates. (yes, they were ripped directly from Lib_EnergyAttack
		local threshold1 = 6
		local threshold2 = threshold1+25
		local threshold3 = threshold2+20
		
		local state_charging = 12
		local attackready = (player.actiontime >= threshold1 and player.actionstate == state_charging)
		local charging = player.exhaustmeter and ((B.PlayerButtonPressed(player,player.battleconfig_special,true) or not(attackready)) and player.actionstate == state_charging)
	
		local state_placing = -22
		local state_placed = -21
		local wallready = (player.actionstate == state_placing)
		local wallplace = (wallready and doaction == 0)
		local wallplacing = (wallready and B.PlayerButtonPressed(player,player.battleconfig_special,true)) --(player.actionstate == state_placing)
		local cancelwall = (wallready and doaction == 2 and (B.PlayerButtonPressed(player,BT_TOSSFLAG,false) or B.PlayerButtonPressed(player,player.battleconfig_guard,false)))
	
		local rolltrigger = attackready and B.PlayerButtonPressed(player,BT_SPIN,false)
		local rockwave = not(rolltrigger) and attackready and doaction == 0 and attackready
		local chargehold = (attackready and B.PlayerButtonPressed(player,player.battleconfig_special,true))
		local idletrigger = not(rolltrigger) and attackready and doaction == 2 and B.PlayerButtonPressed(player,BT_TOSSFLAG,false)
		local canceltrigger =
			not(rockwave or rolltrigger or idletrigger)
			and player.actionstate == state_charging
			and doaction == 2
			and (
				player.exhaustmeter == 0
				or B.PlayerButtonPressed(player,player.battleconfig_guard,false)
			)
		
		if player.gemmarockwall
			if player.gemmarockwall.valid and player.gemmarockwall.health
			and player.gemmarockwall.type == MT_GEMMAWALL
				player.gemmarockwall.target = mo
				player.action2text = "\x80".."Wall HP \x83"..player.gemmarockwall.health.."/3"
				
				if not P_IsObjectOnGround(mo) or player.actionstate
					player.actiontext = "Rock Wave"
					player.actionrings = 10
				else
					player.actiontext = "Destroy wall"
					player.actionrings = 0
				end
			else
				player.gemmarockwall = nil
				S_StartSound(mo, sfx_jshard, player)
				B.ApplyCooldown(player,TICRATE*3)
			end
		elseif P_IsObjectOnGround(mo) and not player.actionstate
			player.actiontext = "Earth Wall"
			player.actionrings = 10
		else
			player.actiontext = "Rock Wave"
			player.actionrings = 10
		end
		player.action2rings = 0
		
		if not(B.CanDoAction(player)) or P_IsObjectInGoop(mo)
			player.actionstate = 0 --Default action state
		return end
		
		-- Intercepted while charging
		if (player.actionstate == state_charging) and player.powers[pw_nocontrol] then
			player.actionstate = 0
			player.actiontime = 0
			B.ApplyCooldown(player,cooldown_cancel)
			return
		end
		
		-- Wall
		if player.actionstate == state_placing then
			player.actiontext = "Earth Wall"
			player.action2text = "Cancel"
			player.pflags = $|PF_JUMPSTASIS
			
			local function drawLine(mo, color, pos)
					local dist = (mo.scale)*pos.x
					local dist2 = (mo.scale)*pos.y
					local angle = mo.angle+ANGLE_90
					
					-- starting offset
					local x1 = mo.x + FixedMul(dist, cos(angle))
					local y1 = mo.y + FixedMul(dist, sin(angle))

					-- offset to the side of (x1, y1)
					local xoffs = x1 + FixedMul(dist2, cos(angle-ANGLE_90))
					local yoffs = y1 + FixedMul(dist2, sin(angle-ANGLE_90))
					local zoffs = (mo.z+pos.z*FRACUNIT) - (mobjinfo[MT_THOK].height/3)

					local thokmobj = P_SpawnMobj( --P_SpawnMobjFromMobj(mo, 
						xoffs, 
						yoffs, 
						zoffs,--zoffs+z_teleoff,
					MT_THOK)
					
					local oldheight = thokmobj.height
					thokmobj.frame = $|FF_FULLBRIGHT--|FF_PAPERSPRITE
					thokmobj.scale = mo.scale/2
					thokmobj.color = color
					thokmobj.fuse = 1
					thokmobj.angle = mo.angle
					thokmobj.fuse = 1
					
					if consoleplayer ~= player then thokmobj.flags2 = $|MF2_DONTDRAW end
					if P_MobjFlip(mo) == -1 thokmobj.z = $-(thokmobj.height-oldheight) end
					thokmobj.flags = $&~MF_NOCLIP&~MF_NOCLIPHEIGHT|MF_NOCLIPTHING
			end
			
			-- NOTE: this is only an estimation of the real range of the wall, it's not precise!
			local function drawCube(mo, color)
				local x = (mobjinfo[MT_GEMMAWALL].radius/FRACUNIT)
				local y = (x*2)
				local z = x/3
				local height = mobjinfo[MT_GEMMAWALL].height/FRACUNIT
				
				-- mr. inefficient 2
				-- Ground hologram
				for i=-y, y, 16    do drawLine(mo, color, {x=i,y=y,z=z}) end
				for i=y, -y, -16   do drawLine(mo, color, {x=i,y=z,z=z}) end
				for i=-x/2, x, 16  do drawLine(mo, color, {x=y,y=x+i,z=z}) end
				for i=-x/2, x, 16  do drawLine(mo, color, {x=-y,y=x+i,z=z}) end
				
				-- Air hologram
				for i=-y, y, 16    do drawLine(mo, color, {x=i,y=y,z=height}) end
				for i=y, -y, -16   do drawLine(mo, color, {x=i,y=z,z=height}) end
				for i=-x/2, x, 16  do drawLine(mo, color, {x=y,y=x+i,z=height}) end
				for i=-x/2, x, 16  do drawLine(mo, color, {x=-y,y=x+i,z=height}) end
				
				-- Edge columns
				for i=z, x*2, 16  do drawLine(mo, color, {x=y,y=y,z=i}) end
				for i=z, x*2, 16  do drawLine(mo, color, {x=y,y=z,z=i}) end
				for i=z, x*2, 16  do drawLine(mo, color, {x=-y,y=y,z=i}) end
				for i=z, x*2, 16  do drawLine(mo, color, {x=-y,y=z,z=i}) end

			end
			
			-- todo: add scale parameter?
			local function checkRange()			
				local thokmobj = P_SpawnMobjFromMobj(mo, 
					FixedMul(128*cos(mo.angle), mo.scale), 
					FixedMul(128*sin(mo.angle), mo.scale), 
					0,--mo.z + mo.height, 
				MT_THOK)
				thokmobj.fuse = 1
							
				local oldheight = thokmobj.height
				thokmobj.radius = FixedMul(mobjinfo[MT_GEMMAWALL].radius*2, mo.scale)
				thokmobj.height = FixedMul(mobjinfo[MT_GEMMAWALL].height, mo.scale)
				thokmobj.flags2 = $|MF2_DONTDRAW
							
				if P_MobjFlip(mo) == -1 thokmobj.z = $-(thokmobj.height-oldheight) end
				thokmobj.flags = $&~MF_NOCLIP&~MF_NOCLIPHEIGHT|MF_NOCLIPTHING
				
				if P_TryMove(thokmobj, mo.x+FixedMul(128*cos(mo.angle), mo.scale),
					mo.y+FixedMul(128*sin(mo.angle), mo.scale), true)
					and thokmobj.z - thokmobj.scale*8 <= mo.z + mo.height
					and thokmobj.z + thokmobj.height + thokmobj.scale*8 >= mo.z
				then
					local foundmobj = 0
					searchBlockmap("objects", function(refmobj, mobj)
						if not (mobj and mobj.valid and mobj.health
							and mobj != mo and mobj.flags&(MF_SHOOTABLE|MF_SOLID))
							or R_PointToDist2(refmobj.x, refmobj.y, mobj.x, mobj.y) > refmobj.radius + mobj.radius
							or refmobj.z - refmobj.scale > mobj.z + mobj.height
							or refmobj.z + refmobj.height + refmobj.scale < mobj.z
						then
							return
						end
								
						foundmobj = mobj
					end, thokmobj)	
				if foundmobj or abs((thokmobj.z + thokmobj.height/2) - (mo.z + mo.height/2)) > mo.height then return SKINCOLOR_RED end
					return SKINCOLOR_GREEN
				else
					return SKINCOLOR_RED
				end
			end
			
			local color = checkRange()
			drawCube(mo, color)
			
			if cancelwall then
				B.ResetPlayerProperties(player,false,false)
				player.actiontime = -1
				player.actionstate = 0
				S_StartSound(mo,sfx_s3k7d)
				B.ApplyCooldown(player,TICRATE*3)				
			elseif wallplace then
				player.actionstate = state_placed
				player.actiontime = 0
			end
			return
		elseif player.actionstate == state_placed then
			S_StartSound(mo, sfx_s3kcbs)
			S_StartSound(mo, sfx_cdfm23)
			
			local thokmobj = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			local oldheight = thokmobj.height
			thokmobj.radius = FixedMul(mobjinfo[MT_GEMMAWALL].radius*2, mo.scale)
			thokmobj.height = FixedMul(mobjinfo[MT_GEMMAWALL].height, mo.scale)
			thokmobj.flags2 = $|MF2_DONTDRAW
					
			if P_MobjFlip(mo) == -1
				thokmobj.z = $-(thokmobj.height-oldheight)
			end
					
			thokmobj.flags = $&~MF_NOCLIP&~MF_NOCLIPHEIGHT|MF_NOCLIPTHING
			if P_TryMove(thokmobj, mo.x+FixedMul(128*cos(mo.angle), mo.scale),
				mo.y+FixedMul(128*sin(mo.angle), mo.scale), true)
				and thokmobj.z - thokmobj.scale*8 <= mo.z + mo.height
				and thokmobj.z + thokmobj.height + thokmobj.scale*8 >= mo.z
			then
				local foundmobj = 0
				searchBlockmap("objects", function(refmobj, mobj)
					if not (mobj and mobj.valid and mobj.health
						and mobj != mo and mobj.flags&(MF_SHOOTABLE|MF_SOLID))
						or R_PointToDist2(refmobj.x, refmobj.y, mobj.x, mobj.y) > refmobj.radius + mobj.radius
						or refmobj.z - refmobj.scale > mobj.z + mobj.height
						or refmobj.z + refmobj.height + refmobj.scale < mobj.z
					then
						return
					end
							
					foundmobj = mobj
				end, thokmobj)
						
				if foundmobj or abs((thokmobj.z + thokmobj.height/2) - (mo.z + mo.height/2)) > mo.height
					S_StartSound(mo, sfx_s3k8c, player)
				else
					player.gemmarockwall = P_SpawnMobjFromMobj(thokmobj, 0, 0, 0, MT_GEMMAWALL)
					player.gemmarockwall.flags = $|MF_NOCLIPTHING
					player.gemmarockwall.angle = mo.angle
					player.gemmarockwall.target = mo
					player.gemmarockwall.gemmaid = -1
							
					if not (gametyperules & GTR_FRIENDLY)
						player.gemmarockwall.color = player.skincolor
						player.gemmarockwall.colorized = true
					end
							
					B.PayRings(player)
					B.ApplyCooldown(player,TICRATE)
				end
			else
				thokmobj.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
				P_TryMove(thokmobj, mo.x+FixedMul(128*cos(mo.angle), mo.scale),
					mo.y+FixedMul(128*sin(mo.angle), mo.scale), true)
					S_StartSound(mo, sfx_s3k8c, player)
			end
			player.actionstate = 0
			player.actiontime = 0
			return
		end
		
		if player.actionstate
			player.actiontime = $ + 1
			
			mo.momx = $*7/8
			mo.momy = $*7/8
			
			-- Rock wave
			if player.actionstate == state_charging
				if player.exhaustmeter < FRACUNIT then
					player.action2text = "Charge "..100*player.exhaustmeter/FRACUNIT.."%"
				end
					
				if player.actiontime == threshold2 then
					S_StartSound(mo,sfx_s1c3)
					for l = 0,8
						P_SpawnParaloop(mo.x,mo.y,mo.z+mo.height/2,256*mo.scale,16,MT_BOXSPARKLE,mo.angle+45*l*ANG1,nil,1)
					end
					player.gemmawave = 1
				end
				if player.actiontime == threshold3 then
					S_StartSound(mo,sfx_s1c3)
					for l = 0,8
						P_SpawnParaloop(mo.x,mo.y,mo.z+mo.height/2,256*mo.scale,16,MT_BOXSPARKLE,mo.angle+45*l*ANG1,nil,1)
					end
					player.gemmawave = 2
				end
					
				player.mo.state = S_PLAY_ROLL
				player.canguard = false
				player.pflags = $|PF_JUMPSTASIS|PF_THOKKED -- rev: PF_THOKKED prevents AbilitySpecial intervention
				player.exhaustmeter = max(0,$-(FRACUNIT/TICRATE/2))
				
				B.DrawAimLine(player,mo.angle)
					
				-- Draw ground range
				-- ?.DrawGroundRange(player, mo.angle)
					
				if not(player.actiontime&3) then
					S_StopSoundByID(mo, sfx_kc38)
					S_StartSound(mo, sfx_kc38)
						
					local ghost = P_SpawnGhostMobj(mo)
					ghost.spritexscale = mo.spritexscale
					ghost.spriteyscale = mo.spriteyscale
					ghost.colorized = true
					ghost.blendmode = AST_ADD
					ghost.scalespeed = ghost.scale/16
					ghost.destscale = $*16
				end
					
				-- mr inefficient
				if rockwave then
					player.actionstate = 2--1
					player.actiontime = 0
					player.exhaustmeter = FRACUNIT
				elseif canceltrigger then
					--B.ResetPlayerProperties(player,false,false)
					player.actionstate = 0
					player.actiontime = -1
					S_StartSound(mo,sfx_s3k7d)
					B.ApplyCooldown(player,TICRATE*3)
					S_StopSoundByID(mo, sfx_kc38)
					player.exhaustmeter = FRACUNIT
				elseif rolltrigger then
					mo.state = S_PLAY_ROLL
					P_InstaThrust(player.mo, player.cmd.angleturn<<16, 39*FRACUNIT) -- Fixed speed thok--(player.actiontime)*FRACUNIT) -- variable speed thok
					player.actionstate = 0
					player.actiontime = 0
					
					S_StopSoundByID(mo, sfx_kc38)
					S_StartSound(mo,sfx_cdfm01)
					B.ApplyCooldown(player,TICRATE*3)
					player.pflags = $|PF_THOKKED
					player.exhaustmeter = FRACUNIT
				elseif idletrigger then
					mo.state = S_PLAY_ROLL
					player.actionstate = 0
					player.actiontime = 0
					S_StopSoundByID(mo, sfx_kc38)
					S_StartSound(mo,sfx_s3k7d)
					B.ApplyCooldown(player,TICRATE*3)
					player.pflags = $|PF_THOKKED
					player.exhaustmeter = FRACUNIT
				end
				
				player.drawangle = mo.angle
				player.pflags = ($|PF_JUMPED)&~PF_NOJUMPDAMAGE
				P_SetObjectMomZ(mo,FRACUNIT/2,false) //Rise slowly
				
			elseif player.actionstate == 1
				mo.momz = $/2
				
				if player.actiontime == TICRATE/3
					player.actionstate = 2
					player.actiontime = 0
					player.exhaustmeter = FRACUNIT
					
					P_SetObjectMomZ(mo, 16*FRACUNIT, false)
					S_StartSound(mo, sfx_kc38)
					S_StartSound(mo, sfx_3db16)
					S_StopSoundByID(mo, sfx_s3kcbs)
				end
			elseif player.actionstate == 2
				player.exhaustmeter = FRACUNIT
				if player.actiontime == TICRATE/3
					player.actionstate = 3
					player.actiontime = 0
					
					S_StartSound(mo, sfx_s3k83)
					S_StopSoundByID(mo, sfx_kc38)
					S_StopSoundByID(mo, sfx_3db16)
				end
			elseif player.actionstate == 3
				if P_IsObjectOnGround(mo) or P_IsObjectInGoop(mo)
					player.pflags = $|PF_FULLSTASIS
					player.actionstate = 4
					player.actiontime = 0
					
					S_StartSound(mo, sfx_kc40)
					S_StartSound(mo, sfx_s3kccs)
					S_StopSoundByID(mo, sfx_s3k83)
					
					if player == displayplayer and not splitscreen
						P_StartQuake(8*FRACUNIT, 7)
					end
					
					local wavespd = 32
					if player.gemmawave then
						if player.gemmawave == 1 then wavespd = $*2
						elseif player.gemmawave == 2 then wavespd = $*3
						end
						player.gemmawave = 0
					end
					for i = 0, 7
						local dirt = P_SpawnMobjFromMobj(mo, 0,0,0, MT_GEMMADIRT)
						P_Thrust(dirt, player.drawangle - ANGLE_45 + (ANGLE_11hh*i), wavespd*mo.scale)
						
						dirt.target = mo
						dirt.hit_sound = sfx_hit01
						dirt.blockable = 2
						dirt.block_stun = 4
						dirt.block_sound = sfx_s3k49
						dirt.block_hthrust = 1
						dirt.block_vthrust = 12
						dirt.flags = $|MF_MISSILE
						
						if not (gametyperules & GTR_FRIENDLY)
							dirt.color = player.skincolor
							dirt.colorized = true
						end
					end
				else
					P_SetObjectMomZ(mo, -64*FRACUNIT, false)
					mo.spritexscale = FRACUNIT*2/3
					mo.spriteyscale = FRACUNIT*3/2
				end
			elseif player.actionstate == 4
				mo.state = S_PLAY_GLIDE_LANDING
				player.pflags = $|PF_FULLSTASIS
				
				if player.actiontime == TICRATE
					mo.state = S_PLAY_STND
					
					B.ApplyCooldown(player,TICRATE*3)
					player.actionstate = 0
					player.actiontime = 0
				end
			end
			
			if player.actionstate and player.actionstate >= 0 and player.actionstate < 4
				if not P_IsObjectOnGround(mo)
					mo.z = $ + mo.scale*P_MobjFlip(mo)
				end
				player.pflags = $|P_GetJumpFlags(player)
				mo.state = S_PLAY_JUMP
				player.gemmasquish = 4
				
				if player.actionstate > 1 or not (player.actiontime%3)
					local ghost = P_SpawnGhostMobj(mo)
					ghost.spritexscale = mo.spritexscale
					ghost.spriteyscale = mo.spriteyscale
					ghost.colorized = true
					ghost.blendmode = AST_ADD
					ghost.scalespeed = ghost.scale/16
					ghost.destscale = $*16
				end
			end
			
		elseif player.actionstate == 0
		and doaction == 1
			if not P_IsObjectOnGround(mo)
				player.actionstate = state_charging--1
				player.actiontime = 0
				B.PayRings(player)
				
				S_StartSound(mo, sfx_s3kcbs)
				S_StartSound(mo, sfx_cdfm23)
				S_StartSound(mo, sfx_s3k9c)
				
				for d = 0, 16
					P_SpawnParaloop(mo.x + mo.momx*4, mo.y + mo.momy*4, mo.z + mo.height/2,
					64*mo.scale, 16, MT_NIGHTSPARKLE, d*ANGLE_22h, nil, false)
				end
			elseif player.gemmarockwall and player.gemmarockwall.valid
			and player.gemmarockwall.health and player.gemmarockwall.type == MT_GEMMAWALL
				P_KillMobj(player.gemmarockwall)
			else
				if player.actionstate == 0 then
					player.actionstate = state_placing
					--player.actiontime = 0
					--B.PayRings(player)
					
					--S_StartSound(mo, sfx_s3kcbs)
					--S_StartSound(mo, sfx_cdfm23)
					--S_StartSound(mo, sfx_s3k9c)
				end
				--else
			end
		end
	end
	
	//Stats
	B.SkinVars["gemma"] = {
		special = GemmaBattle,
		func_priority_ext = GarbagePriority7,
	}
end)

//Wall thinker
addHook("MobjThinker", function(mobj)
	if not mobj.gemmaid then return end
	
	if mobj.gemmaid > 0
		if not (mobj.tracer and mobj.tracer.valid and mobj.tracer.health)
		then P_RemoveMobj(mobj) return end
		mobj.scale = mobj.tracer.scale
		mobj.color = mobj.tracer.color
		mobj.colorized = mobj.tracer.colorized
		mobj.frame = 3-mobj.tracer.health
		mobj.blendmode = mobj.tracer.blendmode
		mobj.flags2 = mobj.tracer.flags2
		mobj.eflags = mobj.tracer.eflags
		mobj.target = mobj.tracer.target
		
		if mobj.gemmaid >= 5
			local zoffset = FixedMul(mobj.tracer.spriteyscale, mobj.tracer.height)*P_MobjFlip(mobj)
			local negative = mobj.gemmaid > 5 and -1 or 1
			mobj.angle = mobj.tracer.angle
			
			if mobj.gemmaid >= 7
				zoffset = 0
				mobj.state = S_INVISIBLE
			else
				if P_MobjFlip(mobj) == -1
					zoffset = $ + mobj.tracer.height
				end
				mobj.frame = $+3
			end
			
			P_MoveOrigin(mobj,
			mobj.tracer.x + P_ReturnThrustX(nil, mobj.angle - ANGLE_90, mobj.radius*negative),
			mobj.tracer.y + P_ReturnThrustY(nil, mobj.angle - ANGLE_90, mobj.radius*negative),
			mobj.tracer.z + zoffset)
		else
			local dist = mobj.radius
			mobj.angle = mobj.tracer.angle + ANGLE_90 * (mobj.gemmaid-1)
			mobj.spriteyscale = mobj.tracer.spriteyscale
			
			if not (mobj.gemmaid % 2)
				dist = $/2
			else
				dist = $*2
			end
			
			P_MoveOrigin(mobj,
			mobj.tracer.x + P_ReturnThrustX(nil, mobj.angle - ANGLE_90, dist),
			mobj.tracer.y + P_ReturnThrustY(nil, mobj.angle - ANGLE_90, dist),
			mobj.tracer.z)
		end
	elseif not mobj.cusval
		for i=1,8
			local wall = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_GEMMAWALL)
			wall.target = mobj.target
			wall.tracer = mobj
			wall.sprite = SPR_EWAL
			wall.gemmaid = i
			wall.flags = $|MF_NOCLIPHEIGHT|MF_NOGRAVITY
			
			if wall.gemmaid >= 7
				wall.state = S_INVISIBLE
				wall.angle = mobj.angle
			elseif wall.gemmaid >= 5
				wall.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD
				wall.frame = $+3
				wall.height = wall.scale
				wall.angle = mobj.angle
			else
				if not (i % 2)
					wall.spritexscale = FRACUNIT*2
					wall.radius = $*2
				end
			
				wall.renderflags = $|RF_PAPERSPRITE
				wall.flags = $|MF_PAPERCOLLISION
				wall.angle = mobj.angle + ANGLE_90 * (i-1)
			end
		end
		
		for i = -4, 4
			for d = -4, 4
				local dust = P_SpawnMobjFromMobj(mobj,
				P_ReturnThrustX(nil, mobj.angle, mobj.info.radius/4*d) + P_ReturnThrustX(nil, mobj.angle+ANGLE_90, mobj.info.radius/2*i),
				P_ReturnThrustY(nil, mobj.angle, mobj.info.radius/4*d) + P_ReturnThrustY(nil, mobj.angle+ANGLE_90, mobj.info.radius/2*i),
				0, MT_TNTDUST)
			end
		end
		
		S_StartSound(mobj, mobj.info.seesound)
		mobj.spriteyscale = FRACUNIT/16
		mobj.cusval = 1
	elseif mobj.spriteyscale < FRACUNIT
		mobj.spriteyscale = min($ + FRACUNIT/16, FRACUNIT)
	elseif mobj.fuse % 2
		mobj.flags2 = $|MF2_SHADOW
	else
		mobj.flags2 = $&~MF2_SHADOW
	end
end, MT_GEMMAWALL)

//No colliding the wall with itself
addHook("MobjCollide", function(thing, tmthing)
	if thing and thing.valid and tmthing and tmthing.valid
	and tmthing.type == MT_GEMMAWALL
		return false
	end
end, MT_GEMMAWALL)

//Are we able to damage the wall? Should we transfer the damage to the object source?
addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if not target.fuse and target.target != inflictor
	and target.target != source and not (G_GametypeHasTeams() and target.target
	and target.target.valid and target.target.player and source and source.valid
	and source.player and target.target.player.ctfteam == source.player.ctfteam)
		if target.gemmaid > 0
			if target.tracer and target.tracer.valid
			and not target.tracer.fuse
				if inflictor and inflictor.valid
					S_StartSound(inflictor, target.info.painsound)
				end
				P_DamageMobj(target.tracer, inflictor, source, damage, damagetype)
			end
			return false
		end
		target.fuse = TICRATE
	else
		return false
	end
end, MT_GEMMAWALL)

-- rev: Allow same-team members to walk through your walls
addHook("MobjCollide", function(thing, tmthing)
	if thing and thing.valid and not (thing.renderflags&RF_FLOORSPRITE)
	and tmthing and tmthing.valid and tmthing.player
	and thing.z - thing.scale <= tmthing.z + tmthing.height
	and thing.z + thing.height + thing.scale >= tmthing.z
	and tmthing.player and thing.target.player.ctfteam == tmthing.player.ctfteam
	then
		return false
	end
end, MT_GEMMAWALL)

//Wall collision for damage
addHook("MobjCollide", function(thing, tmthing)
	if thing and thing.valid and not (thing.renderflags&RF_FLOORSPRITE)
	and tmthing and tmthing.valid and tmthing.player
	and tmthing.player.battle_atk and not thing.fuse
	and thing.z - thing.scale <= tmthing.z + tmthing.height
	and thing.z + thing.height + thing.scale >= tmthing.z
	and thing.target != tmthing and not (G_GametypeHasTeams() and thing.target
	and thing.target.valid and thing.target.player
	and tmthing.player and thing.target.player.ctfteam == tmthing.player.ctfteam)
		if thing.gemmaid > 0
			if thing.tracer and thing.tracer.valid and not thing.tracer.fuse
				P_DamageMobj(thing.tracer, tmthing, tmthing, 1, 0)
				if tmthing and tmthing.valid
					local angle = thing.flags & MF_PAPERCOLLISION and thing.angle - ANGLE_90 or R_PointToAngle2(thing.x, thing.y, tmthing.x, tmthing.y)
					S_StartSound(tmthing, thing.info.painsound)
					P_InstaThrust(tmthing, angle,
					max(tmthing.player.speed, 24*thing.scale))
					tmthing.momz = -$
					tmthing.flags = $|MF_NOCLIPTHING
					P_TryMove(tmthing, tmthing.x + tmthing.momx, tmthing.y + tmthing.momy, true)
					tmthing.z = $ + tmthing.momz
					tmthing.flags = $&~MF_NOCLIPTHING
				end
			end
			return false
		else
			P_DamageMobj(thing, tmthing, tmthing, 1, 0)
		end
	end
end, MT_GEMMAWALL)

//Dumb Debris
addHook("MobjFuse", function(mobj) return true end, MT_GEMMAWALL)
addHook("MobjDeath", function(mobj)
	S_StartSound(mobj, mobj.info.deathsound)
	mobj.health = 0
	mobj.tics = TICRATE*2
	mobj.flags = $|MF_NOCLIP
	for z = 0, 4
		for i = -4, 4
			for d = -4, 4
				local rock = P_SpawnMobjFromMobj(mobj,
				P_ReturnThrustX(nil, mobj.angle, mobj.info.radius/4*d) + P_ReturnThrustX(nil, mobj.angle+ANGLE_90, mobj.info.radius/2*i),
				P_ReturnThrustY(nil, mobj.angle, mobj.info.radius/4*d) + P_ReturnThrustY(nil, mobj.angle+ANGLE_90, mobj.info.radius/2*i),
				mobj.info.height - (mobj.info.height/4*z), MT_ROCKCRUMBLE1)
				if rock and rock.valid
					rock.color = mobj.color
					rock.colorized = mobj.colorized
					rock.flags2 = $&~MF2_OBJECTFLIP
					rock.eflags = $&~MFE_VERTICALFLIP
					rock.fuse = TICRATE*5
					rock.died = true -- rev: dumb problems need dumb solutions
				end
			end
		end
	end
	return true
end, MT_GEMMAWALL)

-- rev: dumb problems need dumb solutions
addHook("MobjThinker", function(rock)
		if rock.died then
			rock.scale = $-1500
			rock.shadowscale = rock.scale
			if rock.scale <= TICRATE then P_RemoveMobj(rock) end
		end
end, MT_ROCKCRUMBLE1)

//Dirt stuff
addHook("MobjThinker", function(mobj)
	if not P_IsObjectOnGround(mobj)
		mobj.momz = $ + P_GetMobjGravity(mobj)*7
	elseif leveltime%2 and mobj.state != mobj.info.painstate
		local ngangle = FixedAngle(((leveltime * 42) % 360) << FRACBITS)
		local xofs = sin(ngangle) * (mobj.radius>>FRACBITS) + FixedDiv(mobj.momx*2, mobj.scale)
		local yofs = cos(ngangle) * (mobj.radius>>FRACBITS) + FixedDiv(mobj.momy*2, mobj.scale)

		local spark = P_SpawnMobjFromMobj(mobj, xofs, yofs, 0, MT_BOXSPARKLE)
		spark.fuse = 12
		spark.momz = mobj.height/spark.fuse*P_MobjFlip(mobj)
		spark.momx = mobj.momx/8
		spark.momy = mobj.momy/8
	end
	if mobj.state == mobj.info.painstate
		mobj.spriteyscale = min(abs(TICRATE*2 - mobj.tics) * FRACUNIT/(TICRATE/8), FRACUNIT)
		if mobj.tics == 1
			for i=0, 2
				local ghost = P_SpawnGhostMobj(mobj)
				if i == 1
					S_StartSound(ghost, mobj.info.deathsound)
				end
				ghost.fuse = TICRATE
				ghost.flags = $&~MF_NOGRAVITY
				ghost.flags2 = mobj.flags2&MF2_OBJECTFLIP
				ghost.eflags = mobj.eflags&MFE_VERTICALFLIP
				P_SetObjectMomZ(ghost, 6*FRACUNIT, false)
				if mobj.target and mobj.target.valid and mobj.target.player
					P_InstaThrust(ghost, (i*-ANGLE_90)+(mobj.target.player.cmd.angleturn<<16)+ANGLE_90, 4*mobj.scale)
				else
					P_InstaThrust(ghost, P_RandomKey(ANGLE_MAX), 4*mobj.scale)
				end
				ghost.sprite = SPR_EWAL
				ghost.frame = H+i
			end
		end
	else
		local ghost = P_SpawnGhostMobj(mobj)
		ghost.destscale = ghost.scale*4
		
		if mobj.state >= S_MINUSDIRT1 and mobj.state <= S_MINUSDIRT7
			mobj.tics = min($, 4)
		end
	end
	if mobj.target and mobj.target.valid
		mobj.flags = $|MF_MISSILE&~MF_NOCLIPTHING&~MF_NOGRAVITY
		mobj.health = mobj.info.spawnhealth
	end
end, MT_GEMMADIRT)

addHook("ShouldDamage", function(target, mobj)
	if mobj and mobj.valid and mobj.type == MT_GEMMADIRT
	and (not P_IsObjectOnGround(mobj) or not (target and target.valid and P_IsObjectOnGround(target)))
		return false
	end
end)

local dirtrise = function(target, mobj)
	if mobj and mobj.valid and mobj.type == MT_GEMMADIRT
	and not mobj.threshold and mobj.state != mobj.info.painstate
		mobj.state = mobj.info.painstate
		mobj.spriteyscale = min(abs(TICRATE*2 - mobj.tics) * mobj.scale/(TICRATE/8), mobj.scale)
		mobj.momx = 0
		mobj.momy = 0
		mobj.threshold = 1
		
		if target and target.valid
			mobj.flags = $&~MF_MISSILE
			P_MoveOrigin(mobj, target.x, target.y, mobj.z)
			mobj.flags = $|MF_MISSILE
		end
	end
end
addHook("MobjDamage", dirtrise)
addHook("MobjDeath", dirtrise)