/*
Push & Wind Animations
Original Code by DirkTheHusky
*/

freeslot("S_PLAY_PUSH", "SPR2_PUSH", "SPR2_SHIT")

states[S_PLAY_PUSH] = {
	sprite = SPR_PLAY,
	frame = SPR2_PUSH,
	tics = 4,
	nextstate = S_PLAY_WALK,
}

addHook("PlayerThink", do
	for player in players.iterate
		if player.mo and player.mo.valid
		and (player.mo.skin == "gemma") then
			//Push Frames
			if player.pushtimer == nil
				player.pushtimer = 0
			end
						
			if player.pushtimer < 1
				player.pushtimer = 0
			end
			if player.pushtimer > 3
				player.pushtimer = 3
			end
			
			if player.powers[pw_pushing] < 2
			and not player.pushobject
				player.pushtimer = 0
			end
			if (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_PUSH)
				if P_IsObjectOnGround(player.mo)
					if player.powers[pw_pushing] >= 2
						player.pushtimer = $1 + 1
					else
						player.pushtimer = $1 - 1
					end
					if player.pushtimer > 2
					and player.powers[pw_pushing]
						player.mo.state = S_PLAY_PUSH
						player.mo.frame = ((leveltime / 13) % 4)
					end
				end
			else
				player.pushtimer = 0
			end
		end
	end
end)

//Push function for Pushable Objects

local function pushtrigger(mo, push)
	local player = mo.player
	
	if (push.z > (mo.z + mo.height))
	or (mo.z > (push.z + push.height)) then
		return
	end
	
	if (mo.skin == "gemma") then
		if push.flags & MF_PUSHABLE then
			if mo.state == S_PLAY_PUSH
				mo.tics = 7
			end
			if push.momx and push.momy
				player.drawangle = R_PointToAngle2(0, 0, push.momx, push.momy)
			end
			if mo.state == S_PLAY_PUSH then
				mo.frame = ((leveltime / 13) % 4)
			end
			if mo.state == S_PLAY_WALK then
				mo.state = S_PLAY_PUSH
			end
		end
	end
end

addHook("MobjCollide", pushtrigger, MT_PLAYER)
addHook("MobjMoveCollide", pushtrigger, MT_PLAYER)

//Animations for player powers. It goes in a think frame

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.valid
		and (player.mo.skin == "gemma") then
			//Wind Frames
			if player.powers[pw_carry] == CR_DUSTDEVIL
			and (player.mo.sprite2 == SPR2_PAIN) then
				player.mo.sprite2 = SPR2_WIND
			end
		end
	end
end)